
package facade.mail;

import java.util.Date;
import java.util.Properties;

import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.AddressException;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;

public class MailFacade {
	public void send(
			String smtpHost, 
			String subject, 
			String from, 
			String to, 
			String message) 
	{
		Properties props = System.getProperties();
		props.put("mail.smtp.host", smtpHost);
		Session session = Session.getDefaultInstance(props, null);
		MimeMessage mimeMessage = new MimeMessage(session);
		try {
			mimeMessage.setFrom(new InternetAddress(from));
			mimeMessage.setRecipients(
					Message.RecipientType.TO,
					InternetAddress.parse(from));
				mimeMessage.setSubject(subject);
				mimeMessage.setHeader("Content-Type", "text/html");
				mimeMessage.setSentDate(new Date());
				mimeMessage.setText(message);
				Transport.send(mimeMessage);
		} catch (AddressException e) {
			e.printStackTrace();
		} catch (MessagingException e) {
			e.printStackTrace();
		}
	}
}
