package facade3;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import exception.SQLRuntimeException;
import facade.Book;

/**:
 * Ѓf[^f[^ANZXIuWFNg
 */
public class BookDao {
	/** O */
	private static Log log = LogFactory.getLog(BookDao.class);
	/** RlNV */
	Connection conn;
	/**
	 * RXgN^
	 */
	public BookDao() {
		conn = SqlUtil.createConnection();
	}
	/**
	 * XVȂ܂B
	 * @param book Ѓf[^
	 * @return XV
	 */
	public int update(Book book) {
		// XV
		PreparedStatement st = null;
		try {
			st = conn.prepareStatement(
			"update tbl_book set title=?,price=? where id=?");
			st.setString(1, book.getTitle());
			st.setInt(2, book.getPrice());
			st.setInt(3, book.getId());
			return st.executeUpdate();
		} catch (SQLException e) {
			log.error(e.getMessage(), e);
			throw new SQLRuntimeException(e);
		} finally {
			SqlUtil.close(st);
		}
	}
	/**
	 * }Ȃ܂B
	 * @param book Ѓf[^
	 * @return XV
	 */
	public int insert(Book book) {
		// XV
		PreparedStatement st = null;
		try {
			st = conn.prepareStatement(
				"insert into tbl_book(id,title,price) " +
				"values(?,?,?)");
			st.setInt(1, book.getId());
			st.setString(2, book.getTitle());
			st.setInt(3, book.getPrice());
			return st.executeUpdate();
		} catch (SQLException e) {
			log.error(e.getMessage(), e);
			throw new SQLRuntimeException(e);
		} finally {
			SqlUtil.close(st);
		}
	}
	/**
	 * ConnectionR~bg܂B
	 */
	public void commit() {
		SqlUtil.commit(conn);
	}
	/**
	 * Јꗗ擾܂B
	 * @return Јꗗ
	 */
	public List getAllBooks() {
		// XV
		List books = new ArrayList();
		ResultSet rs = null;
		Statement st = null;
		try {
			st = conn.createStatement();
			String sql ="select * from tbl_book";
			rs = st.executeQuery(sql);
			while(rs.next()) {
				Book book = new Book();
				book.setId(rs.getInt("ID"));
				book.setTitle(rs.getString("TITLE"));
				book.setPrice(rs.getInt("PRICE"));
				books.add(book);
			}
		} catch (SQLException e) {
			log.error(e.getMessage(), e);
			throw new SQLRuntimeException(e);
		} finally {
			SqlUtil.close(rs);
			SqlUtil.close(st);
		}
		return books;
	}
	/**
	 * @param id
	 * @return
	 */
	public Book getBook(int id) {
		// XV
		ResultSet rs = null;
		PreparedStatement st = null;
		try {
			String sql ="select * from tbl_book where id=?";
			st = conn.prepareStatement(sql);
			st.setInt(1, id);
			rs = st.executeQuery();
			if(rs.next()) {
				Book book = new Book();
				book.setId(rs.getInt("ID"));
				book.setTitle(rs.getString("TITLE"));
				book.setPrice(rs.getInt("PRICE"));
				return book;
			} else {
				throw new RuntimeException("Ѓf[^܂B");
			}
		} catch (SQLException e) {
			log.error(e.getMessage(), e);
			throw new SQLRuntimeException(e);
		} finally {
			SqlUtil.close(rs);
			SqlUtil.close(st);
		}
	}

}
