package observer;
import java.util.LinkedList;
import java.util.List;
import java.util.Iterator;

public class ThermometerSubject extends Thermometer
	implements Subject {

	private List observers = new LinkedList();

	public void setTemperature(int temperature) {
		super.setTemperature(temperature);
		notifyObservers(this);
	}

	
	public void addObserver(Observer observer) {
		observers.add(observer);
	}

	public void notifyObservers(Subject subject) {
		Iterator iter = observers.iterator();
		while ( iter.hasNext() ) {
			((Observer)iter.next()).update(subject);
		}
	}
}
