package observeraspect;

import java.util.LinkedList;
import java.util.List;
import java.util.Iterator;

public aspect ObserverAspect {

	public interface Subject { }

	declare parents: Thermometer implements Subject;

	public interface Observer {
		public abstract void update(Subject subject);
	}

	declare parents: BarDisplay implements Observer;

	private List Subject.observers = new LinkedList();

	public void Subject.addObserver(Observer observer) {
		observers.add(observer);
	}

	public void Subject.notifyObservers(Subject subject) {
		Iterator iter = observers.iterator();
		while ( iter.hasNext() ) {
			((Observer)iter.next()).update(subject);
		}
	}

	protected pointcut subjectChange(Subject subject): 
		call( void Thermometer.setTemperature(int)) && target(subject);

	after(Subject subject) returning : subjectChange(subject) {
		subject.notifyObservers(subject);
	}

	public void BarDisplay.update(Subject subject) {
		int temperature = ((Thermometer)subject).getTemperature();
		print(temperature);
	}

}

